/* Exercice 2 */

between(X,L,H) :- X is L, L =< H.
between(X,L,H) :- L1 is L+1, L1 =< H, between(X,L1,H).

testprod(P,K,[]) :- P/K > 200,!.
testprod(P,K,[]) :- K*floor(P/K) =\= P,!.
testprod(P,K,[[K,Q]]) :- Q is floor(P/K).
prodrec(_,[],1) :- !.
prodrec(P,L,K) :- K1 is K-1,prodrec(P,L1,K1), testprod(P,K,L2), append(L1,L2,L).
prods(P,L) :- K is floor(sqrt(P-1)), prodrec(P,L,K).

sumsrec(S,[],K) :- K >= S-K, !.
sumsrec(S,L,K) :- S-K > 200, K1 is K+1, sumsrec(S,L,K1), !.
sumsrec(S,[[K,R]|L],K) :- R is S-K, K1 is K+1, sumsrec(S,L,K1).
sums(S,L) :- sumsrec(S,L,2).

allun([]).	allun([[X,Y]|L]) :- un(X,Y),allun(L).
nonedeux([]).	nonedeux([[X,Y]|L]) :- \+deux(X,Y), nonedeux(L).
nonetrois([]).	nonetrois([[X,Y]|L]) :- \+trois(X,Y), nonetrois(L).

un(X,Y) :- P is X*Y, prods(P,[_,_|_]).
deux(X,Y) :- S is X+Y, sums(S,L), allun(L).
trois(X,Y) :- deux(X,Y), P is X*Y, prods(P,L), delete(L,[X,Y],R), nonedeux(R).
quatre(X,Y) :- trois(X,Y), S is X+Y, sums(S,L), delete(L,[X,Y],R), nonetrois(R).

solve(X,Y) :- between(X,2,200), between(Y,2,200), X<Y, quatre(X,Y).
